<template>
    <div class="wrapper">
        <div class="container-fuild">
            <div id="headTitle">
                <Logo/>
                <h1 id="title" _msttexthash="48503" _msthash="2">
                    {{i18ntext.lngText('service')}}
                </h1>
            </div>
        </div>
        <div class="container-fuild">
            <Header />
            <ol id="topicPath">
                <li style="margin-left: 285px">
                    <router-link to="">
                        <a href="dashbaord">
                            <font style="vertical-align: inherit"></font>
                            <font style="vertical-align: inherit">
                                {{i18ntext.lngText('service')}}
                            </font>
                        </a>
                    </router-link>
                </li>
            </ol>
        </div>
        <div id="product">
            <div class="search-box">
                <div class="search-box-title" id="Bars">
                    <div id="bar" style="padding-left: 0; ">
              <router-link to="Brands">
                <a 
                 class="btn-radius btn btn-sm" href="#" id="bar-1">
                  <i class="fa fa-cog" aria-hidden="true"></i>
                  {{i18ntext.lngText('brands')}}
                </a>
              </router-link>
              <router-link to="/supplies"
                ><a
                  class="btn-radius btn btn-sm"
                  id="bar-1"
                  href="#"
                  style="color: #f8f5b4; margin-top: -2px"
                >
                  <i class="fa fa-cog" aria-hidden="true"></i>
                  {{i18ntext.lngText('supplier')}}
                </a>
              </router-link>
              <router-link to="unitcode">
                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                  <i class="fa fa-cog" aria-hidden="true"></i>
                  {{i18ntext.lngText('unittype')}}
                </a>
              </router-link>
              <router-link to="Group">
                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                  <i class="fa fa-cog" aria-hidden="true"></i>

                  {{i18ntext.lngText('diangosis')}}
                </a>
              </router-link>
              <router-link to="Category">
                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                  <i class="fa fa-cog" aria-hidden="true"></i>

                  {{i18ntext.lngText('category')}}
                </a>
              </router-link>
              <router-link to="exchangerate">
                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                  <i class="fa fa-cog" aria-hidden="true"></i>
                  {{i18ntext.lngText('exchangerate')}}
                </a>
              </router-link>
              <router-link to="paymenMethod">
                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                  <i class="fa fa-cog" aria-hidden="true"></i>
                  {{i18ntext.lngText('payment')}}

                </a>
              </router-link>
              <router-link to="group">
                <a class="btn-radius btn btn-sm" id="bar-1" href="#">
                  <i class="fa fa-cog" aria-hidden="true"></i>
                  {{i18ntext.lngText('groupservice')}}

                </a>
              </router-link>
              <router-link to="company">
                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                  <i class="fa fa-cog" aria-hidden="true"></i>
                  {{i18ntext.lngText('company')}}

                </a>
              </router-link>
              
            </div>
                   
                    <div id="right" >
                        <a class="btn-radius bt-pn btn btn-sm" data-bs-toggle="dropdown" aria-expanded="false"
                        style="float: right; color: #f8f5b4; margin-top: -2px; width:79px">
                        <i class="fas fa-plus" style="padding-right: 5px"> </i>
                        {{i18ntext.lngText('menu')}}
                    </a>
                    <ul class="dropdown-menu">
                        <li>
                            <a @click="showboom()" class="dropdown-item btn btn-primary" data-bs-toggle="modal"
                                data-bs-target="#boomstaticboomId" tabindex="10028">
                                <i class="fa fa-circle-b"></i>{{i18ntext.lngText('boom')}} {{i18ntext.lngText('material')}}</a>
                        </li>
                    </ul>
                    </div>
                </div>
                <div class="search-box-content">
                    <table width="100%" border="0" cellpadding="0" cellspacing="0" class="tbl_search">
                        <tbody>
                            <tr>
                                <th width="10%">{{i18ntext.lngText('product_no')}}</th>
                                <td width="90%">
                                    <input autocomplete="off" :disabled="true" class="string_zen clear_text text" id="search_word_simei_s"
                                        maxlength="50" name="patient_name" size="50" type="text" tabindex="10003"
                                        :value="Tests.product_no">
                                </td>
                            </tr>
                            <tr>
                                <th width="10%">{{i18ntext.lngText('test_name')}}</th>
                                <td width="90%">
                                    <input autocomplete="off" class="string_zen clear_text text" id="search_word_simei_s" maxlength="50"
                                        @change="UpdateProduct(form)" name="patient_name" size="50" type="text"
                                        tabindex="10003" v-model="form.description">
                                </td>
                            </tr>
                            <tr>
                                <th width="10%">{{i18ntext.lngText('groupservice')}}</th>
                                <td width="90%">
                                    <div class="dropdown d-flex">
                                        <button class="dropdown-toggle string_zen clear_text text select-menu" type="button"
                                            id="dropdownMenuButton1" data-bs-toggle="dropdown" aria-expanded="false"
                                            size="50">
                                            {{ form.group_code }}
                                            <i class="fa fa-chevron-down"></i>
                                        </button>
                                        <a href="#" class="btn-addnew">
                                            <router-link to="groupService">
                                                <a href="#" class=""><span class="new">{{i18ntext.lngText('create_new')}}</span></a>
                                            </router-link>
                                        </a>
                                        <div class="dropdown-menu each-drop-menu" aria-labelledby="dropdownMenuButton1">
                                            <p>
                                                <input autocomplete="off" v-model="search_group" class="string_zen clear_text text search-pro-field" size="50"
                                                    type="text" />
                                            </p>
                                            <ul style="list-style: none" class="scrollable-menu">
                                                <li v-for="(group, index) in searchGroup" :key="index"
                                                    @click="getGroupcode(group)">
                                                    <div class="menu-item">
                                                        <p>{{ group.group_code }}</p>
                                                    </div>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                            <tr>
                                <th width="10%">{{i18ntext.lngText('unittype')}}</th>
                                <td>
                                    <div class="dropdown d-flex">
                                        <button class="dropdown-toggle string_zen clear_text text select-menu" type="button"
                                            id="dropdownMenuButton1" data-bs-toggle="dropdown" aria-expanded="false"
                                            size="50">
                                            {{ form.stock_unit_of_measure_code }}
                                            <i class="fa fa-chevron-down"></i>
                                        </button>
                                        <a href="#" class="btn-addnew">
                                            <router-link to="unitcode">
                                                <a href="#" class=""><span class="new">{{i18ntext.lngText('create_new')}}</span></a>
                                            </router-link>
                                        </a>
                                        <div class="dropdown-menu each-drop-menu" aria-labelledby="dropdownMenuButton1">
                                            <p>
                                                <input autocomplete="off" class="string_zen clear_text text search-pro-field" size="50"
                                                    type="text" v-model="search1"/>
                                            </p>
                                            <ul style="list-style: none" class="scrollable-menu">
                                                <li v-for="(unit, index) in searchUnit" :key="index" @click="getunitcode(unit)">
                                                    <div class="menu-item">
                                                        <p>{{ unit.code }}</p>
                                                    </div>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                </td>
                            </tr>

                            <tr>
                                <th width="10%">{{i18ntext.lngText('currency')}}</th>
                                <td width="90%">
                                    <input autocomplete="off" :disabled="true" class="string_zen clear_text text" id="search_word_simei_s" maxlength="50"
                                        name="patient_age" size="20" type="text" tabindex="10003" v-model="form.curency_code">
                                </td>
                            </tr>
                            <tr>
                                <th width="10%">{{i18ntext.lngText('sale_price')}}</th>
                                <td width="90%">
                                    <input autocomplete="off" class="string_zen clear_text text" 
                                        @change="UpdateProduct(form)" name="patient_age" size="20" type="text"
                                         v-model="form.unit_price">
                                </td>
                            </tr>

                        </tbody>
                    </table>
                    <div class="search-box-footer">
                        <div class="button type2" id="uniform-undefined" data-bs-toggle="modal" data-bs-target="#deleteconfirm"><span>
                             <i class="fas fa-plus" style="padding-right: 5px; margin-top: -2px"></i>
                             {{i18ntext.lngText('add_new')}}
                            <input autocomplete="off" type="button"  class="type2"
                                    style="opacity: 0; width: 54px;"
                            ></span>
                        </div>
                        <div class="button type2" id="uniform-undefined" data-bs-toggle="modal" data-bs-target="#alertbell"><span>
                             <i class="fas fa-plus" style="padding-right: 5px; margin-top: -2px"></i>
                                Add subtest
                            <input autocomplete="off" type="button"  class="type2"
                                    style="opacity: 0; width: 54px;"
                            ></span>
                        </div>
                        <router-link to="testserviceview">
                            <div class="button type2" id="uniform-undefined">
                                    <span>
                                    <i class="fa fa-solid fa-arrow-left"></i>
                                    {{i18ntext.lngText('view')}}<input autocomplete="off" type="button"  class="type2"
                                            style="opacity: 0; width: 54px;">
                                    </span>

                            </div>
                        </router-link>
                       
                        <span class="marker"></span>
                    </div>


                </div>
                <div class="box mt-4">
                    <div class="box-content">
                        <table width="100%" border="0" cellpadding="0" cellspacing="0" class="tbl_list tbl_stripe"
                            id="myTable">
                            <thead>
                                <tr>
                                    <th width="20%" class="tb-pro-th">{{i18ntext.lngText('product_no')}}</th>
                                    <th width="22%" class="tb-pro-th">{{i18ntext.lngText('test_name')}}</th>
                                    <th width="23%" class="tb-pro-th">{{i18ntext.lngText('gender')}}</th>
                                    <th width="25%" class="tb-pro-th">{{i18ntext.lngText('normal_value')}}</th>
                                    <th width="10%" class="tb-pro-th"></th>
                                </tr>
                                <tr v-for="(test, index) in allTest" :key="index">
                                    <th>
                                        <input autocomplete="off" :disabled="true" class="string_zen clear_text text" size="50" type="text"
                                            style="width: 80% !important" :value="test.product_no" />
                                    </th>
                                    <th>
                                        <input autocomplete="off" @change="UpdateSingRow(test.id, test)" class="string_zen clear_text text"
                                            size="50" type="text" style="width: 80% !important"
                                            v-model="test.description" />
                                    </th>
                                    <th>
                                        <input autocomplete="off" :disabled="true" class="string_zen clear_text text" size="50" type="text"
                                            style="width: 80% !important" :value="test.test_type" />
                                    </th>
                                    <th>
                                        <input autocomplete="off" @change="UpdateSingRow(test.id, test)" class="string_zen clear_text text"
                                            size="50" type="text" style="width: 80% !important"
                                            v-model="test.normal_value" />
                                    </th>
                                    <th class="bnt-02">
                                        <div class="button type2" id="uniform-undefined"
                                            @click="deletetest(test.product_no)">
                                            <span><input autocomplete="off" type="button" class="type2" style="opacity: 0; width: 54px"
                                                    tabindex="10025" value="display" /><i class="fa fa-trash"
                                                    aria-hidden="true"></i>
                                                    {{i18ntext.lngText('Delete')}}</span>
                                        </div>
                                    </th>
                                </tr>

                            </thead>
                        </table>
                    </div>
                </div>

            </div>
        </div>

        <!-- view modal  -->

        <div class="modal fade ui-modal" id="boomstaticboomId" data-bs-backdrop="static" data-bs-keyboard="false"
            tabindex="-1" aria-labelledby="staticBackdropss" aria-hidden="true">
            <div class="modal-dialog" id="nonbackgroundboom">
                <div class="modal-content ui-dialog" style="box-shadow: none; border-radius: 0 !important; height: 100%">
                    <div class="modal-header">
                        <h5 class="modal-title" id="staticBackdropLabel">
                            {{i18ntext.lngText('boom')}} {{i18ntext.lngText('material')}} : {{ form.product_no }} , {{ form.description }}
                        </h5>
                        <span class="ui-icon ui-icon-closethick" data-bs-dismiss="modal" aria-label="Close"></span>
                    </div>
                    <div class="box-content">
                        <table width="100%" border="0" cellpadding="0" cellspacing="0" class="tbl_list tbl_stripe"
                            id="myTable">
                            <thead>
                                <tr>
                                    <th width="15%">{{i18ntext.lngText('product_no')}}</th>
                                    <th width="20%">{{i18ntext.lngText('description')}}</th>
                                    <th width="15%">{{i18ntext.lngText('quantity')}}</th>
                                    <th width="15%">{{i18ntext.lngText('unittype')}}</th>
                                    <th width="15%"></th>
                                </tr>
                                <tr v-for="form_line in boomproducts">
                                    <th>
                                        <div class="dropdown">
                                            <button @onmouseout="prooductboom(form_line)"
                                                class="dropdown-toggle string_zen clear_text text" type="button"
                                                id="dropdownMenuButton1" data-bs-toggle="dropdown" aria-expanded="false"
                                                size="50" style="width: 80% !important;
                                                    padding-left: 11px;
                                                    padding-right: 19px;
                                                    border: none;
                                                ">
                                                {{ form_line.boom_product_id }}
                                            </button>
                                            <div class="dropdown-menu" aria-labelledby="dropdownMenuButton1" style="
                                                max-height: 400px;
                                                width: 250px;
                                                scroll-behavior: smooth;
                                                padding: 5px;
                                                margin: 5px;
                                                box-shadow: 1px 1px 5px #141417;">
                                                <p>
                                                    <input autocomplete="off" v-model="search" @input="searchMetarial(search)"
                                                        class="string_zen clear_text text" size="50" type="text" style="
                                                        width: 98% !important;
                                                            border: 1px teal solid;
                                                            border-radius: 1px;
                                                        height: 30px;
                                                        " />
                                                </p>
                                                <ul style="list-style: none" class="scrollable-menu">
                                                    <li v-for="(boompro, i) in boompros" :key="i"
                                                        @click="getproduct1(boompro, form_line, 'boomproducr')">
                                                        <div class="menu-item">
                                                            <p style="color: blue">{{ boompro.product_no }}</p>
                                                            <p>{{ boompro.description }}</p>
                                                        </div>
                                                    </li>
                                                </ul>
                                            </div>
                                        </div>
                                    </th>
                                    <th>
                                        <input autocomplete="off" v-model="form_line.description" @change="proboomAutoSave(form_line)"
                                            class="string_zen clear_text text" size="50" type="text"
                                            style="width: 80% !important" />
                                    </th>
                                    <th>
                                        <input autocomplete="off" v-model="form_line.quantity" @change="proboomAutoSave(form_line)"
                                            class="string_zen clear_text text" size="50" type="text"
                                            style="width: 80% !important" />
                                    </th>
                                    <th>
                                        <div class="dropdown">
                                            <button @click="getboomnit(form_line.boom_product_id)"
                                                @onmouseout="prooductboom(form_line)"
                                                class="dropdown-toggle string_zen clear_text text" type="button"
                                                id="dropdownMenuButton1" data-bs-toggle="dropdown" aria-expanded="false"
                                                size="50" style="
                                                        width: 80% !important;
                                                        padding-left: 11px;
                                                        padding-right: 19px;
                                                        border: none;
                                                        height: 18px;
                                                    ">
                                                {{ form_line.bom_unit_of_measure_code }}
                                            </button>
                                            <div class="dropdown-menu" aria-labelledby="dropdownMenuButton1" style="
                                                    max-height: 400px;
                                                    width: 250px;
                                                    scroll-behavior: smooth;
                                                padding: 5px;
                                                    margin: 5px;
                                                    box-shadow: 1px 1px 5px #141417;
                                                    border: none;
                                                ">
                                                <p>
                                                    <input autocomplete="off" v-model="txtsearch" @input="searchproduct(txtsearch)"
                                                        class="string_zen clear_text text" size="50" type="text" style="
                                                            width: 98% !important;
                                                            border: 1px teal solid;
                                                            border-radius: 1px;
                                                            height: 30px;
                                                        " />
                                                </p>
                                                <ul style="list-style: none" class="scrollable-menu">
                                                    <li v-for="unit in boomUnit" @click="getupdateunit(unit, form_line)">
                                                        <div class="menu-item">
                                                            <p>{{ unit.variant_unit_of_measure_code }}</p>
                                                        </div>
                                                    </li>
                                                </ul>
                                            </div>
                                        </div>
                                    </th>
                                    <th class="bnt-02">
                                        <div class="button type2" id="uniform-undefined" @click="deleteboom(form_line.id)">
                                            <span><input autocomplete="off" type="button" class="type2" style="opacity: 0; width: 54px"
                                                    tabindex="10025" value="display" /><i class="fa fa-trash"
                                                    aria-hidden="true"></i>
                                                    {{i18ntext.lngText('Delete')}}</span>
                                        </div>
                                    </th>
                                </tr>
                            </thead>
                        </table>
                    </div>
                    <div class="modal-footer">
                        <a @click="boomcratenew()" class="btn-radius bt-pn btn btn-sm show" href="#"
                            data-bs-toggle="dropdown" aria-expanded="true"
                            style="float: left; color: rgb(248, 245, 180); margin-top: -2px"><i class="fas fa-plus"
                                style="padding-right: 5px; margin-top: -2px"></i>{{i18ntext.lngText('add_new')}}</a>
                        <div class="button type2" id="uniform-undefined"></div>
                        <div class="button type2" id="uniform-undefined"></div>
                    </div>
                </div>
            </div>
        </div>
        <!-- Bell alert -->
      
        <!-- confirm add new modal -->
        <div class="modal fade ui-modal" id="deleteconfirm" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"
            aria-labelledby="clearconfirm" aria-hidden="true">
            <div class="modal-dialog smallpopup" id="nonbackgroundboom">
                <div class="modal-content ui-dialog">
                    <div class="ui-widget-header">
                        <h5 class="modal-title" id="exampleModalLabel">
                            <span class="ui-dialog-title" id="ui-dialog-title-modal-edit-dialog">{{i18ntext.lngText('confirm_message')}}</span>
                        </h5>
                        <span class="ui-icon ui-icon-closethick btn-cancel" data-bs-dismiss="modal"
                            aria-label="Close"></span>
                    </div>
                    <div class="ui-dialog-content" style="background-color: #fff;">
                        <div class="modal-body">{{i18ntext.lngText('create_message')}}</div>
                        <div class="modal-footer">
                            <div class="button type2" id="uniform-undefined" data-bs-dismiss="modal" @click="cancel()">
                                <span>{{i18ntext.lngText('No')}}<input autocomplete="off" type="button" class="type2" tabindex="10008" value="No"
                                        style="width: 89px; opacity: 0;">
                                </span>
                            </div>
                            <div class="button type2" data-bs-dismiss="modal" @click="createTest()"><span>{{i18ntext.lngText('yes')}}</span>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div id="myModal" class="lskymodal">
            <div class="lskymodal-content">
                <p><i class="fa fa-check" aria-hidden="true"></i> {{ message }}</p>
            </div>
        </div>

    </div>

    <div
    class="modal fade ui-modal"
    id="alertbell"
    data-bs-backdrop="static"
    data-bs-keyboard="false"
    tabindex="-1"
    aria-labelledby="staticboomId"
    aria-hidden="true"
  >
    <div class="modal-dialog" style="max-width: 130vh !important">
      <div class="modal-content ui-dialog">
        <div class="ui-widget-header">
          <h5 class="modal-title in-header" id="staticBackdropLabel">
            <i class="fa fa-print" aria-hidden="true"></i> Add sub service test
          </h5>
          <span
            class="ui-icon ui-icon-closethick"
            data-bs-dismiss="modal"
            aria-label="Close"
          ></span>
        </div>
        <div class="ui-dialog-content" id="purchaseorder1">
          <div>
            <div class="card-body">
              <div class="mt-3">
                <div>
                  <div class="my-2">
                    <table class="table table-striped br-table">
                      <thead>
                        <tr class="header-table">
                            <th colspan="5">
                                <div @click="addSubtest()" disabled="false" class="button type2" id="uniform-undefined" style="float: left;">
                                    <span style="width: 150px;">
                                        <input autocomplete="off" type="button" class="type2" style="opacity: 0; width: 54px;">
                                        <i class="fas fa-plus"></i>Add Sub service 
                                    </span>
                                </div>
                            </th>
                        </tr>
                        <tr class="header-table">
                          <th  class="text-center" style="text-align: center !important; width:20%">
                            <div class="d-flex" style="flex-direction:column">
                                <p>Sub service no</p> 
                                <input type="text" disabled autocomplete="off" class="string_zen clear_text text" v-model="sub_form.sub_product_no"/>
                            </div>
                            
                          </th>
                          <th  class="text-center" style="text-align: center !important; width:25%">
                            <div class="d-flex" style="flex-direction:column">
                                <p>Name</p>
                                 <input @change="updateSubtest()" type="text" class="string_zen clear_text text" v-model="sub_form.description"/>
                            </div>
                            
                          </th>
                          <th class="text-center" style="text-align: center !important;">
                           <span>Unit type </span> 
                            <div class="dropdown">
                      <button 
                        class="dropdown-toggle string_zen clear_text text select-menu-button" type="button"
                        id="dropdownMenuButton1" data-bs-toggle="dropdown" aria-expanded="false" size="50"
                        style="height: 25px">
                        {{ sub_form.stock_unit_of_measure_code }} 
                      </button>
                      <div class="dropdown-menu each-drop-menu" aria-labelledby="dropdownMenuButton1" style="height:140px; overflow:scroll">
                        <p>
                          <input autocomplete="off" v-model="search2"
                            class="string_zen clear_text text search-pro-field" size="50" type="text" />
                        </p>
                        <ul style="list-style: none" class="scrollable-menu">
                          <li v-for="(unit, index) in searchSubunit" @click="getUnitsubtest(unit)">
                            <div class="menu-item"><p>{{ unit.code }}</p></div>
                          </li>
                        </ul>
                      </div>
                    </div>
                          </th>
                          <th></th>
                          <th></th>
                        </tr>

                        <tr v-if="sub_form.product_no != '' && sub_form.product_no != null" class="header-table">
                            <th></th>
                          <th class="text-center" style="text-align: center !important">
                            Product no
                          </th>
                          <th class="text-center" style="text-align: center !important">
                            Name 
                          </th>
                          <th class="text-center" style="text-align: center !important">
                            Gender 
                          </th>
                          <th class="text-center" style="text-align: center !important">
                            Normal Value 
                          </th>
                          
                        </tr>
                        <tr class="header-table" v-for="(item, index) in sub_list" :key="index">
                            <th></th>
                          <th class="text-center" style="text-align: center !important">
                            <input type="text" disabled v-model="item.product_no" class="string_zen clear_text text" style="width:100%" />
                          </th>
                          <th class="text-center" style="text-align: center !important">
                            <input type="text" disabled v-model="item.description" class="string_zen clear_text text" style="width:100%"/>
                          </th>
                          <th class="text-center" style="text-align: center !important">
                            <input type="text" disabled v-model="item.test_type" class="string_zen clear_text text" style="width:100%"/> 
                          </th>
                          <th class="text-center" style="text-align: center !important">
                            <input type="text" @change="UpdateSingRow(item.id, item)" v-model="item.normal_value" class="string_zen clear_text text" style="width:100%"/>
                          </th>
                          
                        </tr>
                       
                       
                        <tr class="header-table">
                            <th colspan="5">
                                <h5>View sub service</h5>
                            </th>
                        </tr>
                        <tr class="header-table">
                            <th style="text-align:center !important">No</th>
                            <th>Sub service no</th>
                            <th>Name</th>
                            <th>Unit type</th>
                            <th></th>
                        </tr>
                      </thead>
                      <tbody>
                        <tr v-for="(item, index) in subTests" :key="index">
                            <td style="text-align:center !important">{{ index + 1 }}</td>
                            <td>{{ item.sub_product_no }}</td>
                            <td>{{ item.description }}</td>
                            <td>{{ item.stock_unit_of_measure_code }}</td>
                            <td>
                                <div class="d-flex justify-content-center">
                                    <div class="button" @click="getOnesubtest(item.sub_product_no)">
                                    <span ><i class="fa fa-edit"></i>
                                         {{ i18ntext.lngText('edit') }}
                                         <input autocomplete="off" type="button" style="opacity: 0; width: 70px"/>
                                    </span>
                                </div>
                                <div class="button" @click="deleteSubTest(item.id)">
                                    <span><i class="fa fa-edit"></i>
                                        {{ i18ntext.lngText('Delete') }}
                                        <input autocomplete="off" type="button" style="opacity: 0; width: 70px"/>
                                    </span>
                                </div>
                                </div>
                                
                            </td>
                        </tr>
                      </tbody>
                    </table>
                  </div>
                  <hr />
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="modal-footer">
          <div class="button type2" id="uniform-undefined"  data-bs-dismiss="modal"
            aria-label="Close">
            <span><input autocomplete="off" type="button"
                class="type2"
                tabindex="10025"
                value="display"
                style="opacity: 0; width: 54px"/>
                <i class="fa fa-save" aria-hidden="true"></i> {{ i18ntext.lngText('close') }}
            </span>
          </div>
        </div>
      </div>
    </div>
  </div>

    <Footer/>
    <UserInfo/>
</template>
<script>

import Header from '../Header.vue'
import axios from "axios";
import Logo from "../logo.vue"
import Auth from '../../auth/Auth';
import i18n from "../../i18n/i18n";
import UserInfo from "../UserInfo.vue";
import Footer from "../footer.vue";
export default {
    name: "test",
    components: { Header,Logo,Footer, UserInfo },
    data() {
        return {
            i18ntext: i18n,
            currency_code: '',
            btn_save: false,
            form: {
                id: '',
                product_no: '',
                product_barcode: '',
                description: '',
                description_2: '',
                image_url: '',
                stock_unit_of_measure_code: '',
                purche_unit_of_measure_code: '',
                bom_no: '',
                reorder_point: '',
                sup_code: '',
                brand_code: '',
                group_code: '',
                cat_code: '',
                variant_code: '',
                unit_price: '',
                inactived: '',
                is_deleted: '',
                type: '',
                curency_code : ''
            },
            search: '',
            eachform: {
                id: '',
                product_no: '',
                product_type: '',
                description: '',
                test_type: '',
                normal_value: '',
                status: '',
                remark: '',
                created_by: '',
                delete_by: '',

            },
            units: [],
            search1 : '',
            search2 : '',

            boomproducts: [],
            message: '',
            groups: [],
            Tests: [],
            allTest: [],
            TestID: "",
            getid: "",
            boompros: [],
            boomUnit: [],
            sub_form : {
                id: '',
                product_no : '',
                sub_product_no : '',
                description : '',
                stock_unit_of_measure_code: '',
                created_by: '',
                updated_by : Auth.user.id
            },
            sub_list : [],
            subTests : [],
            search_group: '',


        }
    },
    async mounted() {
        if (Auth.check()) {
        if(!Auth.checkPermission('SERVICE_ALL')){
            this.$router.push('/dashboard');
        }
    }
        try {
            if (this.$route.query.id.trim() != "undefined") {
                this.TestID = this.$route.query.id;
                this.Tests.product_no = this.TestID
            }
        } catch (error) {
        }
        this.getServiceTest()
        this.getAllTest()
        this.showboom()
        this.getunit()
        this.getCurrency()
        this.getdatagroup()
        this.prooductboom();
        this.getAllsubtest()
    },
    //computed property
    computed:{
        searchUnit(){
            return this.units.filter((el) => (el.code.toLocaleLowerCase()).includes((this.search1).toLocaleLowerCase()))
        },
        searchSubunit(){
            return this.units.filter((el) => (el.code.toLocaleLowerCase()).includes((this.search2).toLocaleLowerCase()))
        },
        searchGroup(){
            return this.groups.filter((el) => (el.group_code.toLocaleLowerCase()).includes((this.search_group).toLocaleLowerCase()))
        }
    },
    methods: {
        show_saveBtn() {
            this.btn_save = true;
        },

        async createTest() {
            await axios.post("/api/v1/testservice/create/"+Auth.user.id)
                .then(res => {
                    this.Tests = res.data[0]
                    this.form = res.data[0]
                    this.$router.push({
                        name: "test",
                        query: { id: this.Tests.product_no },
                    });
                    this.show_saveBtn()
                    this.getAllTest()
                    this.sub_form = {
                        id: '',
                        product_no : '',
                        sub_product_no : '',
                        description : '',
                        stock_unit_of_measure_code: '',
                        created_by: '',
                        updated_by : Auth.user.id
                    }
                    this.sub_list = []
                    this.subTests = []
                })
        },
        async getCurrency() {
            await axios.get("/api/v1/getSetup/")
                .then((res) => {

                    this.currency_code = res.data.main_Currency
                })
                .catch()
        },
        async getdatagroup() {
            await axios.get("/api/v1/group/SelectGroupservice/").then((response) => {
                this.groups = response.data;
            });
        },
        async deletetest(id) {
            await axios.get("api/v1/testservice/destroy/" + id)
                .then(res => {
                    this.getAllTest()
                    this.Tests = res.data
                })
        },
        async UpdateSingRow(id, form) {
            this.eachform = form;
            await axios.post("/api/v1/testservice/update/" + id, this.eachform)
                .then((res) => {
                    this.message = "save successful."
                    form = res.data;
                    this.messagebox()
                })
        },
        messagebox() {
            var modal = document.getElementById("myModal");
            modal.style.display = "block";
            setTimeout(() => (modal.style.display = "none"), 1500);
        },
        prooductboom() {
            axios.get("/api/v1/boomproduct/getMetarial/").then((response) => {
                this.boompros = response.data;
                console.log(this.boompros)
            });
        },

        getproduct1(boom, product, txt) {
            if (txt == "boomproducr") {
                product.boom_product_id = boom.product_no;
                product.description = boom.description;
                this.proboomAutoSave(product);
                this.prooductboom();
            }
        },
        proboomAutoSave(product) {
            axios.put("/api/v1/boomproduct/update/" + product.id, product).then((response) => {
                this.prooductboom();
            });
            this.messagebox();
            this.prooductboom();
        },
        async UpdateProduct(form) {
            await axios.post("/api/v1/products/update/" + this.Tests.product_no, form)
                .then(res => {
                    this.form = res.data
                    this.message = "Save successful"
                    this.messagebox()
                    this.getAllTest()
                })
        },
        getGroupcode(group) {
            this.form.group_code = group.group_code
            this.UpdateProduct(this.form)
        },
        getunitcode(unit) {
            this.form.stock_unit_of_measure_code = unit.code
            this.UpdateProduct(this.form)
        },
        async showboom() {
            await axios
                .get("/api/v1/boomproduct/show/" + this.Tests.product_no)
                .then((response) => {
                    this.boomproducts = response.data;
                });
        },
        async boomcratenew() {
            await axios.post("/api/v1/boomcreate/" + this.Tests.product_no).then((response) => {
                this.boomproducts = response.data;
                console.log(this.boomproducts)
            });
        },
        async deleteboom(id) {
            await axios.get("/api/v1/boomproduct/destroy/" + id)
                .then(res => {
                    this.boomproducts = res.data
                })
        },
        async getunit() {
            await axios.get("/api/v1/getunitservice")
                .then(res => {
                    this.units = res.data

                })
        },
        getupdateunit(unit, product) {
            product.bom_unit_of_measure_code = unit.variant_unit_of_measure_code
            this.proboomAutoSave(product)
        },

        async getAllTest() {
            await axios.get("/api/v1/testservice/gettestservice/" + this.Tests.product_no)
                .then(res => {
                    this.allTest = res.data
                    this.allTest.forEach(element => {
                        element.description = this.form.description;
                        this.getupdateTest(element.id, element);
                    });
                })
        },
        async getupdateTest(id, form) {
            this.eachform = form;
            await axios.post("/api/v1/testservice/update/" + id, this.eachform)
                .then((res) => {
                    this.message = "save successful."
                })
        },
        async getServiceTest() {
            await axios.get('api/v1/products/getProductServicetest/' + this.TestID)
                .then(res => {
                    this.form = res.data
                })
        },
        // async
        async getboomnit(product_no){
            await axios.get('api/v1/boomproduct/getMetarialUnit/'+product_no)
                        .then(res => {
                            this.boomUnit = res.data
                        })
        },
        async searchMetarial(search){
            await axios.post('api/v1/boomproduct/searchMetarial/'+search)
                        .then(res => {
                           this.boompros = res.data
                        })
        },
        //method for subtest
        addSubtest(){
            if(this.form.product_no != '' && this.form.product_no != null){
                axios.post("api/v1/testservice/createSubtest/"+Auth.user.id,this.form)
                    .then(res => {
                        console.log(res.data)
                        this.sub_form = res.data.subtest
                        this.sub_list = res.data.list
                        this.getAllsubtest()
                    })
            }
            else{
                alert("can't create")
            }
        },
      async  getAllsubtest(){
            if(this.$route.query.id != '' && this.$route.query.id){
                await axios.get('api/v1/testservice/getAllsubtest/'+this.$route.query.id)
                            .then(res => {
                                this.subTests = res.data 
                            })
            }
            else{
                console.log('nothong to get data')
            }
        },
        deleteSubTest(id){
            axios.get('api/v1/testservice/deleteSubtest/'+id)
                .then(res => {
                    this.message = "Delete successfully"
                    this.messagebox()
                    this.getAllsubtest()
                    this.getOnesubtest(this.sub_form.sub_product_no)
                })
        },
        updateSubtest(){
            if(this.sub_form.id != '' && this.sub_form.id != null){
                axios.post('api/v1/testservice/updateSubtest/'+this.sub_form.id,this.sub_form)
                    .then(res => {
                        this.message = "Update sucessfully"
                        this.messagebox()
                        this.getAllsubtest()
                        this.getOnesubtest(this.sub_form.sub_product_no)
                    })
            }
        },
        getOnesubtest(id){
            axios.get('api/v1/testservice/getOneSubtest/'+id)
                .then(res => {
                    if(res.data.subtest == null){
                        this.sub_form = {
                            id: '',
                            product_no : '',
                            sub_product_no : '',
                            description : '',
                            stock_unit_of_measure_code: '',
                            created_by: '',
                            updated_by : Auth.user.id
                        }
                    }
                    else{
                        this.sub_form = res.data.subtest
                    }
                    
                    this.sub_list = res.data.list
                })
        },
        getUnitsubtest(unit){
            console.log(unit)
            this.sub_form.stock_unit_of_measure_code = unit.code
            this.updateSubtest()
        }


    }
};
</script>
